#ifndef PSO_ALGO_H_INCLUDED
#define PSO_ALGO_H_INCLUDED


//********************************************************************************************************************
void localeSearch_Swap(Particule &sol);

void GenererUneSolutionAleatoire(Particule &sol)
{



    for(iterc ic=sol.conf.begin(); ic!=sol.conf.end(); ic++)
    {

        (*ic).x= fRand(-sol.LMax/2.0 + (*ic).r,sol.LMax/2.0 -(*ic).r);;  //
        (*ic).y=fRand(-h/2.0 +(*ic).r,h/2.0 -(*ic).r);;                   //
        (*ic).z=fRand(-w/2.0 +(*ic).r,w/2.0 -(*ic).r);;                   //


        (*ic).Vx =fRand(-(*ic).r,(*ic).r);
        (*ic).Vy =fRand(-(*ic).r,(*ic).r);
        (*ic).VZ =fRand(-(*ic).r,(*ic).r);

    }




}



// ******************************************************************************************************************
// Generer une population aleatoire
//*******************************************************************************************************************

Population GenererUnePopulation(listc instance)
{

    long double best=10000000.0;
    InitializationSolution(G_best);
    Population listP;

    listP.clear();

    while(listP.size()<POPULATIOSIZE)
    {

        Particule p;
        InitializationSolution(p);

        p.LMax=l_sup;//l_inf+fRand(0.0,1.0)*(l_sup-l_inf);
        printf("\n bonn p.code=%d p.Lmax=%lf  \n",p.code,p.LMax );

        p.V_Lmax=fRand(-0.5,0.5);
        p.conf=instance;


        GenererUneSolutionAleatoire(p);

         //draw(p.conf,p.LMax);

            p.penality=quasi_physicalMileu(p.conf,p.LMax);
            localeSearch_Swap(p);
        //draw(p.conf,p.LMax);

   printf("\n bonn p.code=%d p.Lmax=%lf, p.penality=%14.10lf  \n",p.code,p.LMax, p.penality);

        if(p.penality<EPSILON)
        {

            p.code=listP.size()+1;
            p.conf_Pbest=p.conf;
            p.LMax_Pbest=p.LMax;
            printf("\n bonn p.code=%d p.Lmax=%lf, p.penality=%14.10lf  p.LMax_Pbest=%lf \n",p.code,p.LMax, p.penality,p.LMax_Pbest );


            listP.push_back(p);

            if(p.LMax<best)
            {
                best=p.LMax;
                G_best=p;


            }



        }

    }


    return listP;
}




void localeSearch_Swap(Particule &sol)
{


       sol.penality=quasi_physicalMileu(sol.conf,sol.LMax);

       if(sol.penality<EPSILON)return;
        listc  bestconf=sol.conf;
        double bestPenality=sol.penality;


printf("\n  begin Local searche   bestPenality=%lf  sol.LMax=%lf \n",bestPenality,sol.LMax);

label1:
    for(int i=0; i<n-1;i++)
    for(int j=i+1;j<n;j++)
       {
           listc confv; confv.clear(); confv=bestconf;
           sort(confv.begin(),confv.end(),compare_circle_pain);

        if(confv[i].forceelistic.RDPi>EPSILON||confv[j].forceelistic.RDPi>EPSILON)
           {


         //    draw(confv,sol.LMax);

             Circle c; //c.forceelistic.RDPi
              c=confv[i];

            confv[i].x= confv[j].x;
            confv[i].y= confv[j].y;
            confv[i].z= confv[j].z;
            confv[j].x= c.x;
            confv[j].y= c.y;
            confv[j].z= c.z;


                        // draw(confv,sol.LMax);

            double penality=quasi_physicalMileu(confv,sol.LMax);
                                    // draw(confv,sol.LMax);

//printf("\n   penality=%lf   \n",penality);


               if(penality<bestPenality)
                 {
                     bestPenality=penality;
                     bestconf=confv;
                 //    printf("\n local serache   bestPenality=%10.8lf   \n",bestPenality);
                     if(bestPenality<sol.penality)
                        {
                         sol.penality=bestPenality;
                         sol.conf=bestconf;

                           if( sol.penality<EPSILON)
                                {
                            sort(sol.conf.begin(),sol.conf.end(),compare_circle_code);

                            printf("\n   fin    ******  Local searche   sol.penality=%10.8lf   \n",sol.penality);
                                //  draw(sol.conf,sol.LMax);
                                return;
                                    }


                   if(sol.LMax<G_best.LMax_Pbest)goto label1;
                        }


                            }else if(penality<bestPenality+0.2* bestPenality)
                                {
                              //  printf("\n  ******  Local searche   Accept    penality=%10.8lf    bestPenality+0.2* bestPenality=%10.8lf \n",penality, bestPenality+0.2* bestPenality);
                                  bestconf=confv;
                                    }




           }


       }


printf("\n   fin    ******  Local searche   sol.penality=%10.8lf  sol.LMax=%lf  \n",sol.penality,sol.LMax);
}



Particule TS_BPA(Particule p)
 {

   Particule bestone=p;
printf("\n TS_BPA  begin  bestone.lmax =%lf  bestone.penality=%lf \n", bestone.LMax,bestone.penality);

   double Lmin=p.LMax;
   double Lmax=p.LMax+0.2*G_best.LMax_Pbest;
printf("\n TS_BPA   Lmin=%lf Lmax=%lf \n",Lmin,Lmax); //getchar();
     while(Lmax-Lmin>0.01)
        {
          Particule p_local=bestone;

          p_local.LMax=(Lmax+Lmin)/2.0;


                localeSearch_Swap(p_local);


              if(p_local.penality<EPSILON)
                  {
                    bestone=p_local;
                    Lmax= p_local.LMax;
                        printf("\n TS_BPA Amerloration  best bestone.lmax=%lf\n", bestone.LMax);

                       // if(bestone.LMax<=p.LMax&&bestone.LMax>G_best.LMax_Pbest+0.2*G_best.LMax_Pbest) break;
                        }else
                            {
                            if(p_local.penality<bestone.penality+0.2*bestone.penality)
                                      {
                                       bestone=p_local;

                                      }
                                Lmin=p_local.LMax;

                                    }

        }

printf("\n sort   bestone.lmax =%lf  bestone.penality=%lf \n", bestone.LMax,bestone.penality);


 return bestone;

 }

Particule threshold_operator(Particule p, Population listVoisinage)
 {


  double thred=p.penality+2*p.penality/10;

                         for(iterP ip=listVoisinage.begin();ip!=listVoisinage.end();ip++)
                            {
                                (*ip).penality=quasi_physicalMileu((*ip).conf,(*ip).LMax);
                    //localeSearch((*ip));
                                if((*ip).penality<EPSILON)
                                    {
                                        p=(*ip);
                                        listVoisinage.clear();
                                        return p;
                                            }

                                       else if((*ip).penality<thred)
                                              {

                                               thred=(*ip).penality+2*(*ip).penality/10;


                                                }
                                                else
                                                  {
                                                  listVoisinage.erase(ip--);


                                                  }


                                                }

                      //  printf("\n apres filtering  voisinage listVoisinage=%d \n",listVoisinage.size());

                           if( listVoisinage.empty())return p;
                             else
                               {
                          listVoisinage.push_back(p);
                          sort(listVoisinage.begin(),listVoisinage.end(),compare_Particule_penaity);
                               for(iterP ip=listVoisinage.begin();ip!=listVoisinage.end();ip++)
                                     {
                                       localeSearch_Swap(*ip);
                                     //(*ip)=TS_BPA((*ip));
                                      if((*ip).penality<EPSILON)
                                          {
                                           p=(*ip);
                                           return p;
                                           } else
                                              {
                                               if((*ip).penality<p.penality)
                                                {
                                                 p=(*ip);

                                                }


                                              }

                                     }


                               }


 p=TS_BPA(p);

 return p;


 }





void UpdateParticule(Particule & p, Particule PV)
{

 //Update L Vaiable
Population listVoisinage; listVoisinage.clear();



    p.V_Lmax=0.792*(p.V_Lmax+fRand(0.0,1.0)*2.05*(p.LMax_Pbest-p.LMax)+fRand(0.0,1.0)*2.05*(PV.LMax_Pbest-p.LMax));

            if(p.V_Lmax>0.5)p.V_Lmax=0.5;
            if(p.V_Lmax<-0.5)p.V_Lmax=-0.5;
             p.LMax=p.LMax+p.V_Lmax;


 //Update x,y,z  Vaiables

     for(int i=0; i<n; i++)
       {

        double x=p.conf[i].x;
        double y=p.conf[i].y;
         double z=p.conf[i].z;
           p.conf[i].Vx= 0.792*(p.conf[i].Vx+fRand(0.0,1.0)*2.05*(p.conf_Pbest[i].x-p.conf[i].x)+fRand(0.0,1.0)*2.05*(PV.conf_Pbest[i].x-p.conf[i].x));
           p.conf[i].Vy= 0.792*(p.conf[i].Vy+fRand(0.0,1.0)*2.05*(p.conf_Pbest[i].y-p.conf[i].y)+fRand(0.0,1.0)*2.05*(PV.conf_Pbest[i].y-p.conf[i].y));
           p.conf[i].VZ= 0.792*(p.conf[i].VZ+fRand(0.0,1.0)*2.05*(p.conf_Pbest[i].z-p.conf[i].z)+fRand(0.0,1.0)*2.05*(PV.conf_Pbest[i].z-p.conf[i].z));

          if(p.conf[i].Vx>p.conf[i].r )p.conf[i].Vx=p.conf[i].r ;
          if(p.conf[i].Vx<-p.conf[i].r )p.conf[i].Vx=-p.conf[i].r ;


            if(p.conf[i].Vy>p.conf[i].r )p.conf[i].Vy=p.conf[i].r ;
            if(p.conf[i].Vy<-p.conf[i].r  )p.conf[i].Vy=-p.conf[i].r ;

             if(p.conf[i].VZ>p.conf[i].r )p.conf[i].VZ=p.conf[i].r ;
             if(p.conf[i].VZ<-p.conf[i].r  )p.conf[i].VZ=-p.conf[i].r ;

            p.conf[i].x=p.conf[i].x+p.conf[i].Vx;

            p.conf[i].y=p.conf[i].y+p.conf[i].Vy;

            p.conf[i].z=p.conf[i].z+p.conf[i].VZ;


    if(fabs(x-p.conf[i].x)>EPSILON||fabs(y-p.conf[i].y)>EPSILON||fabs(z-p.conf[i].z)>EPSILON)
       {
        Particule Sol_voisine;
        InitializationSolution(Sol_voisine);
       Sol_voisine=p;

       listVoisinage.push_back(Sol_voisine);
       }


           }
 //printf("\n avant filtering  voisinage listVoisinage=%d \n",listVoisinage.size());
           p.penality=quasi_physicalMileu(p.conf,p.LMax);
               if( p.penality<EPSILON)return;
                else if(p.LMax<1.2*PV.LMax_Pbest)// &&!listVoisinage.empty())
                        {


     p=threshold_operator(p,listVoisinage);

                        }


 }















void PSO_Algorithme(listc instance)
{

    int Niteration=1000;
    int i=0;

     double dsecondSinceStart;
    time_t start = time(0);
    dsecondSinceStart = difftime (time(0), start);

    Population listofp=GenererUnePopulation(instance);

 //printf("\n listofp.size()=%d\n",listofp.size());

    while(dsecondSinceStart<TMAX)
      {
        i++;
        dsecondSinceStart = difftime (time(0), start);
        //sort(listofp.begin(),listofp.end(),compare_Particule);



        for(iterP ip=listofp.begin(); ip!=listofp.end(); ip++)
           {

             Particule p;
             p=(*ip);


            UpdateParticule( p,G_best);

            dsecondSinceStart = difftime (time(0), start);
            (*ip).T=difftime (time(0), start);
             (*ip)=p;
         if(p.penality<EPSILON)(*ip)=p;
          else
            {
             if(p.LMax< 1.2*p.LMax_Pbest)(*ip)=p;
             else if(fRand(0.0,1.0)>0.5)
                 {

               (*ip)=p;
                }



            }


            printf("\n i=%d p.code=%d p.Act=%lf, p.Actpenality=%14.10lf  pBes=%lf, G_best.LMax_Pbest=%lf T=%lf \n",i,(*ip).code,(*ip).LMax, (*ip).penality,(*ip).LMax_Pbest,G_best.LMax_Pbest,dsecondSinceStart);

            if((*ip).penality<EPSILON&& (*ip).LMax<(*ip).LMax_Pbest)
            {
                (*ip).conf_Pbest=(*ip).conf;

                (*ip).LMax_Pbest=(*ip).LMax;
            printf("\n Update bestpersonnele p.Act=%lf, p.Actpenality=%14.10lf  pBes=%lf, G_best.LMax_Pbest=%lf T=%lf \n",(*ip).LMax, (*ip).penality,(*ip).LMax_Pbest,G_best.LMax_Pbest,dsecondSinceStart);

                if((*ip).LMax_Pbest<G_best.LMax_Pbest)
                {

                    G_best=(*ip);
            printf("\n bestpersonnele gbest p.Act=%lf, p.Actpenality=%14.10lf  pBes=%lf, G_best.LMax_Pbest=%lf T=%lf \n",(*ip).LMax, (*ip).penality,(*ip).LMax_Pbest,G_best.LMax_Pbest,dsecondSinceStart);
                    WriteIntoEXternalFichier(dsecondSinceStart);
                //  draw(G_best.conf_Pbest,G_best.LMax_Pbest);
                    afficher_cercles(G_best.conf);

                }

            }


        }

    }

}



#endif // PSO_ALGO_H_INCLUDED
