#ifndef FUNCTIONDIVERS_H_INCLUDED
#define FUNCTIONDIVERS_H_INCLUDED


//**************************************************************************************************************************
                                // critiere de sort
//*****************************************************************************************************************

 bool compare_circle_code(const Circle c1, const Circle c2){return c1.code<c2.code;}
 bool compare_circle_r(const Circle c1, const Circle c2){return c1.r>c2.r;}
 bool compare_circle_painR(const Circle c1, const Circle c2){return c1.forceelistic.RDPi>c2.forceelistic.RDPi;}
 bool compare_circle_pain(const Circle c1, const Circle c2){return c1.forceelistic.DPi>c2.forceelistic.DPi;}
 bool compare_Sol_density(const Particule s1, const Particule s2){return s1.densite>s2.densite;}
 bool compare_Sol_Lmax(const Particule s1, const Particule s2){return s1.LMax<s2.LMax;}
 bool compare_Particule(const Particule p1, const Particule p2){return p1.LMax_Pbest<p2.LMax_Pbest;}
 bool compare_Particule_penaity(const Particule p1, const Particule p2){return p1.penality<p2.penality;}

//****************************************************************************************************
                                            // fonctions divers
//****************************************************************************************************
 double sqr( double x){return x*x;}
 double cub( double x){return x*x*x;}
 double dist(Circle c1, Circle c2){return sqrt(sqr(c1.x-c2.x)+sqr(c1.y-c2.y)+sqr(c1.z-c2.z));}


bool intersect(Circle p1, Circle p2)
   {
   if ((dist(p1,p2)-p1.r-p2.r)<-EPSILON) return true;
   return false;
  }


 double fRand( double fMin,  double fMax){
    double f = ( double)rand() / RAND_MAX;
    return fMin + f * (fMax - fMin);}



double calcule_la_densite( listc conf,  double solution)
{
  double surfance_conf=0.0;
  double densite_conf=0.0;

 for(iterc ic=conf.begin();ic!=conf.end();ic++)
      {
        surfance_conf+=(4.0/3.0)*M_PI*cub((*ic).r);

       }

 densite_conf=surfance_conf/(h*w*solution);
return densite_conf;
}



 void ChangeLerepereVersMilieu(listc &conf,  double solution)
  {

  for(iterc ic=conf.begin();ic!=conf.end();ic++)
   {
    (*ic).x=(*ic).x-solution/2;
    (*ic).y=(*ic).y-h/2;
    (*ic).z=(*ic).z-w/2;
    }

  }


   void ChangeLerepereVersBottomLeft(listc &conf, double solution)
  {

    for(iterc ic=conf.begin();ic!=conf.end();ic++)
      {
     (*ic).x=(*ic).x+solution/2;
     (*ic).y=(*ic).y+h/2;
     (*ic).z=(*ic).z+w/2;
    }

  }


#endif // FUNCTIONDIVERS_H_INCLUDED
