#ifndef WINGPROCEDURE_H_INCLUDED
#define WINGPROCEDURE_H_INCLUDED


using namespace std;



//*********************************************************************************************************************
// block - local quise phisique
//*********************************************************************************************************************

  void Re_initialisationForce(listc &conf)
  {

    for(iterc ic=conf.begin(); ic!=conf.end(); ic++)
       {
        InitializationForceElistic(*ic);
        }



  }


  Circle Calculer_Cordonnee_CentreCercleOfIntersection(Circle &i,Circle &j)
   {

      Circle  c_center;
     InitializationCircle(c_center);
  double distanceCenter=dist(i,j);
  double interS=i.r+j.r-distanceCenter;

  // cas 1: Si d = 0 , alors les sphères S et S' sont concentriques
       // si r = r' alors les deux sphères sont confondues
       // si r ≠ r' alors les deux sphères n'ont aucun point en commun.

 if(dist(i,j)<EPSILON &&i.r!=j.r)
   {
        //printf("\n ********************* if(dist(i,j)<EPSILON &&i.r!=j.r)   \n"); //getchar();

        if(i.r>j.r)
         {
          j.x=i.x+(i.r+j.r);
          j.y=i.y+(i.r+j.r);
          j.z=i.z+(i.r+j.r);

         }
         else
          {

           i.x=j.x+(i.r+j.r);
           i.y=j.y+(i.r+j.r);
           i.z=i.z+(i.r+j.r);


          }




       }


  // cas 2 :

//   Si d ≠ 0
//        si d < |r - r'| alors l'une des deux sphères est à l'intérieur de l'autre et l'intersection est vid
//        si d = |r - r'| alors les sphères S et S' sont tangentes intérieurement
//        si |r - r'|< d < r + r' alors les sphères S et S' sont sécantes et leur intersection est un cercle de H (H appartient à la droite (OO') et où I est le milieu de [OO'] ) )
//        si d = r + r' alors les sphères S et S' sont tangents extérieurement
//        si d > r + r' alors les sphères S et S' sont extérieures l'une à l'autre ( elle n'ont pas de points en commun dans ce cas )
//

   //  si d < |r - r'| alors l'une des deux sphères est à l'intérieur de l'autre et l'intersection est vid
     if(dist(i,j)>EPSILON &&dist(i,j)<fabs(i.r-j.r))
       {

        if(i.r>j.r)
         {
              j.x=i.x+(i.r+j.r);
              j.y=i.y+(i.r+j.r);
              j.z=i.z+(i.r+j.r);

         }
         else
          {

           i.x=j.x+(i.r+j.r);
           i.y=j.y+(i.r+j.r);
           i.z=j.z+(i.r+j.r);

          }




       }

       //si d = |r - r'| alors les sphères S et S' sont tangentes intérieurement
    if(dist(i,j)==fabs(i.r-j.r))
       {

        j.x+=2*j.r;
        j.y+=2*j.r;
        j.z+=2*j.r;
       distanceCenter=dist(i,j);


       }

//        si |r - r'|< d < r + r' alors les sphères S et S' sont sécantes et leur intersection est un cercle de H (H appartient à la droite (OO') et où I est le milieu de [OO'] ) )

   if(dist(i,j)>fabs(i.r-j.r)&&dist(i,j)<i.r+j.r)
       {

       double b=0.0;
       double a=0.0;
       double x=sqr(j.r)+sqr(dist(i,j))-sqr(i.r);
        b= x/(2.0*dist(i,j));
        a= dist(i,j)-b;
       if(a<b)
         {
            double dd=sqr(i.r)-sqr(a); if(dd<EPSILON) dd=0.0;
         c_center.r=sqrt(dd);
          if(sqr(i.r)<sqr(a))printf("\n ***sqr(i.r)=%lf****************** sqr(a) =%lf   \n",sqr(i.r),sqr(a)); //getchar();

         }
         else {
         double dd=sqr(i.r)-sqr(b);
          if(dd<EPSILON) dd=0.0;
           c_center.r=sqrt(dd);
         // if(sqr(i.r)<sqr(b))printf("\n ***sqr(i.r)=%lf****************** sqr(b) =%lf   \n",sqr(i.r),sqr(b)); //getchar();

         }

         c_center.x=i.x+(a/dist(i,j))*(j.x-i.x);

        c_center.y=i.y+(a/dist(i,j))*(j.y-i.y);
       c_center.z=i.z+(a/dist(i,j))*(j.z-i.z);


   return c_center;


       }

   }



 double calculet_PenalityFonctionMileu(listc &conf, double sol)
{

        double penality=0.0;
        Re_initialisationForce(conf);

// elstic force avec les autres circles
           for(int i=0;i<n-1; i++)
                for(int j=i+1;j<n; j++){

                if(intersect(conf[i],conf[j]))  // ici intersection
                     {

                      Circle c_center; InitializationCircle(c_center);
                      c_center=Calculer_Cordonnee_CentreCercleOfIntersection(conf[i],conf[j]);


                  double Dij=(conf[i].r+conf[j].r)-dist(conf[i],conf[j]);
                  penality+= sqr(Dij);

                        double dij=conf[i].r-sqrt(sqr(c_center.x-conf[i].x)+sqr(c_center.y-conf[i].y)+sqr(c_center.z-conf[i].z) );


                      if(conf[i].x-conf[j].x>EPSILON)  conf[i].forceelistic.Feij_x+= dij*(conf[i].x-conf[j].x)/fabs(conf[i].x-conf[j].x);//fabs(sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z))-);
                       else  conf[i].forceelistic.Feij_x+= dij*(conf[i].x-conf[j].x);
                 if(conf[i].y-conf[j].y>EPSILON)conf[i].forceelistic.Feij_y+= dij*(conf[i].y-conf[j].y)/fabs(conf[i].y-conf[j].y);//sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z)));
                  else conf[i].forceelistic.Feij_y+= dij*(conf[i].y-conf[j].y);
                    if(conf[i].z-conf[j].z>EPSILON) conf[i].forceelistic.Feij_z+= dij*(conf[i].z-conf[j].z)/fabs(conf[i].z-conf[j].z);//sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z)));
                     else conf[i].forceelistic.Feij_z+= dij*(conf[i].z-conf[j].z);


                     conf[i].forceelistic.sqr_dij+=sqr(Dij); // a verifier


                double dji=Dij-dij;

            if(conf[j].x-conf[i].x>EPSILON)conf[j].forceelistic.Feij_x+=dji*(conf[j].x-conf[i].x)/fabs(conf[j].x-conf[i].x);//fabs(sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z))-);
               else conf[j].forceelistic.Feij_x+=dji*(conf[j].x-conf[i].x);


                if(conf[j].y-conf[i].y>EPSILON)conf[j].forceelistic.Feij_y+= dji*(conf[j].y-conf[i].y)/fabs(conf[j].y-conf[i].y);//sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z)));
                   else conf[j].forceelistic.Feij_y+= dji*(conf[j].y-conf[i].y);

                if(conf[j].z-conf[i].z>EPSILON) conf[j].forceelistic.Feij_z+= dji*(conf[j].z-conf[i].z)/fabs(conf[j].z-conf[i].z);//sqrt(sqr((*ic).x-(*ic1).x) +sqr((*ic).y-(*ic1).y)+sqr((*ic).z-(*ic1).z)));
                  else conf[j].forceelistic.Feij_z+= dji*(conf[j].z-conf[i].z);


                     conf[j].forceelistic.sqr_dij+=sqr(Dij);


                }

    }

      //  Overlappe with bordures



    for(iterc ic=conf.begin(); ic!=conf.end(); ic++)
       {
            double mix=0.0;double miy=0.0;  double  miz=0.0;
            if(fabs((*ic).x)+(*ic).r-(sol/2.0)>EPSILON)
                {
                    mix=(fabs((*ic).x)+(*ic).r-(sol/2.0));
                        if(fabs((*ic).x)<EPSILON)(*ic).forceelistic.Feij_x+=mix*(-(*ic).x)/fabs((*ic).x);//(sqrt(sqr((*ic).x) +sqr((*ic).y)+sqr((*ic).z)));
                            else (*ic).forceelistic.Feij_x+=mix*(-(*ic).x);

                        (*ic).forceelistic.sqr_dvi=sqr(mix);       //    embedding depth between circle i et cotes sur x axe  =max(0,ri+xi-w)

                    }

            if(fabs((*ic).y)+(*ic).r-(h/2.0)>EPSILON)
                {
                    miy=(fabs((*ic).y)+(*ic).r-(h/2.0));
                        if(fabs((*ic).y)>EPSILON)(*ic).forceelistic.Feij_y+=miy*(-(*ic).y)/fabs((*ic).y);//(sqrt(sqr((*ic).x) +sqr((*ic).y)+sqr((*ic).z)));
                            else  (*ic).forceelistic.Feij_y+=miy*(-(*ic).y);


                        (*ic).forceelistic.sqr_dhi=sqr( miy);       //    embedding depth between circle i et cotes sur y axe  =max(0,ri+yi-w)


                }
            if(fabs((*ic).z)+(*ic).r-(w/2.0)>EPSILON)
                    {
                    miz =(fabs((*ic).z)+(*ic).r-(w/2.0));
                    if(fabs((*ic).z)>EPSILON)(*ic).forceelistic.Feij_z+=miz*(-(*ic).z)/fabs((*ic).z);//sqrt(sqr((*ic).x) +sqr((*ic).y)+sqr((*ic).z));
                    else  (*ic).forceelistic.Feij_z+=miz*(-(*ic).z);

                    (*ic).forceelistic.sqr_dpi=sqr(miz);


                    }

            double loi=sqrt((*ic).forceelistic.sqr_dvi+(*ic).forceelistic.sqr_dhi+(*ic).forceelistic.sqr_dpi);

                (*ic).forceelistic.ui+=(*ic).forceelistic.sqr_dij+(*ic).forceelistic.sqr_dvi +(*ic).forceelistic.sqr_dhi  +(*ic).forceelistic.sqr_dpi;
                (*ic).forceelistic.DPi+=(*ic).forceelistic.ui;
                (*ic).forceelistic.RDPi=(*ic).forceelistic.DPi/((*ic).r);

            penality+=sqr(loi);
    }


    return penality;

}


void UpdatConf_withForce(listc &conf, double solution ,double eps)
 {
            for(iterc ic2=conf.begin(); ic2!=conf.end(); ic2++)
            {

                {

                   (*ic2).x+=eps*(*ic2).forceelistic.Feij_x;

                    (*ic2).y+=eps*(*ic2).forceelistic.Feij_y;//

                   (*ic2).z+= eps*(*ic2).forceelistic.Feij_z;//

                }


            }

 }


void gradiandescent(listc &confV, listc &confx,double &penalityV,double penalityX,double solution)
{
double h=0.1;

//printf("\n   penalityX=%lf \n",penalityX);
   double dsecondSinceStart;
   time_t start = time(0);
printf("\n  entrer penalityV=%lf penalityX=%lf \n",penalityV,penalityX); //getchar();

while(penalityV>10E-10&&fabs(penalityV-penalityX)>10E-10&&h>10E-20&&difftime (time(0), start)<30)
   {
 listc locaConf=confV;
    for(int i=0;i<n;i++)
      {


      if(fabs(locaConf[i].x-confx[i].x)>0.0)//&&penalityV-penalityX>0.0)
       {
       locaConf[i].x=confx[i].x-h*(fabs(penalityV-penalityX)/fabs(locaConf[i].x-confx[i].x));
       if(isnan(locaConf[i].x))
         {
         printf("\n isnan(locaConf[i].x)=%d\n",isnan(locaConf[i].x)); getchar();
         }
       }
       if(fabs(locaConf[i].y-confx[i].y)>0.0)//&&penalityV-penalityX>0.0>EPSILON)
        {
        locaConf[i].y=confx[i].y-h*(fabs(penalityV-penalityX)/fabs(locaConf[i].y-confx[i].y));
        if(isnan(locaConf[i].y))
          {
          printf("\n isnan(locaConf[i].y)=%d\n",isnan(locaConf[i].y));getchar();
          }

        }
      if(fabs(locaConf[i].z-confx[i].z)>0.0)//&&EPSILON&&penalityV-penalityX>0.0)
        {
        locaConf[i].z=confx[i].z-h*(fabs(penalityV-penalityX)/fabs(locaConf[i].z-confx[i].z));
                if(isnan(locaConf[i].z))
                 {
                    printf("\n isnan(locaConf[i].z)=%d\n",isnan(locaConf[i].z)); getchar();
                  }

        }


      }

 double localPenality=calculet_PenalityFonctionMileu(locaConf,solution);


  if(localPenality<penalityV)
    {
     confV=locaConf;
     penalityV=localPenality;

//printf("\n   if(localPenality=%lf <penalityV=%lf) \n",localPenality,penalityV); //getchar();

  }else if(fabs(localPenality-penalityV)<10E-10)
  {
    break;
  }
  else
  {
     h=h*0.9;

  }


dsecondSinceStart = difftime (time(0), start);

}


printf("\n   sort penalityV=%lf penalityX=%lf \n",penalityV,penalityX);// getchar();



}





 double quasi_physicalMileu(listc &conf1,   double solution)
{




listc meilleure_conf; meilleure_conf.clear();
 meilleure_conf=conf1;



      double penality_solution=calculet_PenalityFonctionMileu(conf1,solution);
// printf("\n  befijn penality_solution=%lf  \n",penality_solution); //getchar();

      double meilleurpenality=penality_solution;


       if(meilleurpenality<EPSILON)
         {
         return meilleurpenality;


         }
            else
                {

            listc  bestconflocal;
                    bestconflocal.clear();

                     bestconflocal=conf1;

                    double bestpenal=penality_solution;

                    double eps=1.0;
                        double dsecondSinceStart;
                        time_t start = time(0);


                    while(penality_solution>EPSILON&&eps>10E-30&&difftime (time(0), start)<60)
                            {
                                dsecondSinceStart = difftime (time(0), start);
                                    listc conflocal;
                                    conflocal.clear();
                                    conflocal=bestconflocal;

                                    //draw(conflocal,solution);

                                  UpdatConf_withForce(conflocal,solution,eps);
                               penality_solution=calculet_PenalityFonctionMileu(conflocal,solution);

                                    // printf("\n penality_solution=%lf  \n",penality_solution);

                                    //   draw(conflocal,solution);




                                       if(penality_solution<bestpenal)
                                         {

                                            bestpenal=penality_solution;

                                              bestconflocal.clear();
                                              bestconflocal=conflocal;

                                                 if(bestpenal<meilleurpenality)
                                                    meilleurpenality=bestpenal;

                                                     meilleure_conf.clear();
                                                    meilleure_conf=bestconflocal;

                                               }
//                                                else if(penality_solution-bestpenal<0.0001)
//                                                {
//                                                bestconflocal=conflocal;
//                                                 eps=eps*0.9;
//
//                                                }

                                                else   // reduire stepsize
                                                    {

                                                 if(penality_solution<bestpenal+2.0*bestpenal/10)bestconflocal=conflocal;

                                                eps=eps*0.9;
                                                            }





                                 } // fin while



                      } // fin else

    conf1.clear();
    conf1=meilleure_conf;
// printf("\n  fin  meilleurpenality=%lf  \n",meilleurpenality); //getchar();

//draw(conf1,solution);
    return  meilleurpenality;
}





#endif // WINGPROCEDURE_H_INCLUDED
